#!/usr/bin/perl
#
# $Header: //sapdb/V76/develop/sys/src/install/perl/SAPDB/Install/Grid/CellStateIconRenderer.pm#6 $
# $DateTime: 2005/07/29 12:47:38 $
# $Change: 103252 $
#
# Desc: start SAP DB installation/update/patch/instanceupgrade, called by SDBINST/SDBUPD


package SAPDB::Install::Grid::CellStateIconRenderer;

use base Wx::PlGridCellRenderer;
use Wx qw(wxBLACK_PEN wxWHITE_BRUSH wxCOPY);
use SAPDB::Install::Resources;



our $images = (SAPDB::Install::Resources->
				new('RESOURCES.TGZ'))->getImages('icon/ready.png',
												'icon/process.png',

												'icon/error.png');
our $mem_dc = {};
our $is_wxGTK = Wx::wxGTK;

if(defined $images){
	foreach my $key (keys(%$images)){
		$images->{$key}->Rescale(16,16);
	}
}

sub Draw {
  my( $self, $grid, $attr, $dc,
		 $rect, $row, $col, $sel ) = ( shift, @_ );
  $self->SUPER::Draw( @_ );
  my $value = $grid->GetCellValue( $row, $col );
  my $y = $rect->y;
  unless(exists $mem_dc->{$value}){
	$mem_dc->{$value} = Wx::MemoryDC->new();
	$mem_dc->{$value}->BeginDrawing() if $^O =~ /mswin/i;
	if($value eq 'FINISHED_SUCCESS'){
		$mem_dc->{$value}->SelectObject(Wx::Bitmap->new($images->{'icon/ready.png'}));
	}
       elsif($value eq 'RUNNING'){
		$mem_dc->{$value}->SelectObject(Wx::Bitmap->new($images->{'icon/process.png'}));
	
	}
	elsif($value eq 'FINISHED_ERROR'){
		$mem_dc->{$value}->SelectObject(Wx::Bitmap->new($images->{'icon/error.png'}));
  	}
	$mem_dc->{$value}->EndDrawing() if $^O =~ /mswin/i;
  }	  
  my ($icon_width,$icon_height) =  $mem_dc->{$value}->GetSizeWH; 
  my $y_diff = $rect->GetHeight - $icon_height;  
  if($y_diff > 0){
	$y += int($y_diff/2); 
  }	
 $dc->Blit($rect->x + 20,$y,$mem_dc->{$value}->GetSizeWH,$mem_dc->{$value},0,0,wxCOPY,1);
  	
}

#sub GetBestSize{
#	my ($grid, $attr, $dc, $row,$col) = @_;
#	print ">>> starting bestsize\n";
#	my $size = Wx::Size->new(24,24); 
#	#print ">>>>> size = $size\n";
#	#return \$size;
#}

sub Clone {
  my $self = shift;
  return $self->new;
}



sub Destroy{
	my ($self) = @_;
	self->SUPER::Destroy;
}

1;
