#!/usr/bin/perl
#
# $Header: //sapdb/V76/develop/sys/src/install/perl/SAPDB/Install/Wizard/Dialog/Base.pm#7 $
# $DateTime: 2004/11/23 16:05:21 $
# $Change: 84725 $
#
# Desc: Base class of a Wizard::Dialog
#

package SAPDB::Install::Wizard::Dialog::Base;

use Wx qw ( wxEXPAND wxCENTRE wxICON_ERROR
			wxICON_INFORMATION wxTAB_TRAVERSAL);

our @ISA = qw (Wx::Panel);

sub new{
	my($this ) = shift->SUPER::new(@_);
	$this->SetWindowStyleFlag($this->GetWindowStyleFlag | wxTAB_TRAVERSAL);
	return $this;
}


sub GetWizard{
	my ($self) = @_;
	return $self->GetParent;
}

sub SetError{
	my ($self,$title,$msg) = @_;
	my $msgbox = Wx::MessageDialog->new($self,$msg,
				$title, wxICON_ERROR | wxCENTRE);
	
	$msgbox->ShowModal();
	$msgbox->Destroy;
	
	unless($msg =~ /fatal\serror/){
		if(defined $self->GetParent){
			$self->GetParent->{'config'}->{'container'}->Log->SetMsg("$title: $msg\n")
				if defined $self->GetParent->{'config'}->{'container'};
		}
	}
	return 1;	
}

sub SetMsg{
	my ($self,$title,$msg) = @_;
	my $msgbox = Wx::MessageDialog->new($self,$msg,
				$title, wxICON_INFORMATION | wxCENTRE);
	
	$msgbox->ShowModal();
	$msgbox->Destroy;
	return 1;	
}



sub init{
	my ($self,$config) = @_;
	$self->Enable(1);
	$self->Show(1);
	return {};
}

sub Process{
	my ($self,$config) = @_;
	return {};
}

sub Destroy{
	my ($self) = @_;
	$self->SUPER::Destroy;
}

sub DESTROY{
	my ($self) = @_;
	print ">>>>> destroying $self\n"
		if $SAPDB::Install::DEBUG::DESTRUCT;
}



1;
